Unit AGG0R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG3R_p, AGT0R_p;

procedure AGG0R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var ALFA :Array of Real;
                var BETA :Array of Real; var WK :Array of Real;
                N :Integer; var IERR :Integer);

implementation

procedure AGG0R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var ALFA :Array of Real;
                var BETA :Array of Real; var WK :Array of Real;
                N :Integer; var IERR :Integer);
var
I,J,JA,NPI,IZ2,N2,IS_,IG,IGZ :Integer;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
AFG3R(A,B,V,N,0);
AGT0R(A,B,V,ALFA[0],ALFA[N+0],BETA,N,IERR);
for I:=1 to N do
 begin
  NPI := N+I;
  WK[I-1] := ALFA[NPI-1];
_1:
 end;
JA := N+N;
J := N;
for I:=1 to N do
 begin
  ALFA[JA-2] := ALFA[J-1];
  ALFA[JA-1] := WK[J-1];
  JA := JA-2;
  J := J-1;
_2:
 end;
IZ2 := N+N;
N2 := N+N;
J := N;
_3:
if ( J < 1 )
 then goto _8;
if ( ALFA[2*J-1] = ZERO )
 then goto _6;
IS_ := IZ2*(J-1)+1;
IG := N*(J-2)+1;
IGZ := IG+N;
for I:=1 to N do
 begin
  V[IS_-1] := V[IG-1];
  V[IS_+0] := -V[IGZ-1];
  IS_ := IS_+2;
  IG := IG+1;
  IGZ := IGZ+1;
_4:
 end;
IS_ := IZ2*(J-2)+1;
IG := IS_+IZ2;
for I:=1 to N do
 begin
  V[IS_-1] := V[IG-1];
  V[IS_+0] := -V[IG+0];
  IS_ := IS_+2;
  IG := IG+2;
_5:
 end;
J := J-2;
goto _3;
_6:
IS_ := IZ2*(J-1)+N2;
IG := N*J;
for I:=1 to N do
 begin
  V[IS_-2] := V[IG-1];
  V[IS_-1] := ZERO;
  IS_ := IS_-2;
  IG := IG-1;
_7:
 end;
J := J-1;
goto _3;
_8:
end;

end.
